<?php
// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class scpayanyway {
	var $debugshow="hidden"; // set to text or hidden
	var $paymentsuccess;
	var $paymentfail;
	var $gatewayreturntext;

    function paymentrequest()
    {
        if (isset($_GET['MNT_ID']) && isset($_GET['MNT_TRANSACTION_ID']) && isset($_GET['MNT_OPERATION_ID'])
            && isset($_GET['MNT_AMOUNT']) && isset($_GET['MNT_CURRENCY_CODE']) && isset($_GET['MNT_TEST_MODE'])
            && isset($_GET['MNT_SIGNATURE']))
        {
            $cfg=new sc_configuration();
            $dataintegritycode = $cfg->get("mntdataintegritycode");
            $payanyway_crc	 = md5("{$_GET['MNT_ID']}{$_GET['MNT_TRANSACTION_ID']}{$_GET['MNT_OPERATION_ID']}{$_GET['MNT_AMOUNT']}{$_GET['MNT_CURRENCY_CODE']}{$_GET['MNT_TEST_MODE']}{$dataintegritycode}");
            if ($_GET['MNT_SIGNATURE'] == $payanyway_crc){
                $db	=& JFactory::getDBO();
                $cfg=new sc_configuration();
                $statuses=explode("\r\n", $cfg->get("ostatus"));
                $status=$statuses[count($statuses)-1]; // set the status to the last one in the list

                $scorder=new order();
                $scorder->load($_GET['MNT_TRANSACTION_ID']);
                $scorder->status=$status;
                $scorder->store();
                echo "SUCCESS";
            } else {
                echo "FAIL";
            }
            exit;
        }
        else {
            $mainframe->redirect("index.php?option=com_caddy&action=showcart&Itemid=$Itemid");
            exit;
        }
    }

	function checkout($orderid, $ship=null) {
		// this function will use payanyway for checkout instead of a standard email to the admin
		
		//get PayAnyWay configuration
		$cfg=new sc_configuration();
		$cfp=$cfg->get ("taxrate");
		$cfp=str_replace("%", "", $cfp);
		if ($cfp>1) {
			$cfp=$cfp/100;
		}
		$taxrate=$cfp;
        $odetails=new orderdetail();
        $lst=$odetails->getDetailsByOrderId($orderid);
        $amount = 0;
		foreach ($lst as $product) {
            $amount = $amount + ($product->unitprice * $product->qty);
		}
		if ($taxrate>0) {
            $tax = $amount * $taxrate;
            $amount = $amount + $tax;
        }
        $amount = number_format($amount, 2,".", "");

        $paymentserver = $cfg->get("mntpaymentserver");
        $merchantid = $cfg->get("mntid");
        $testmode = $cfg->get("mnttestmode");
        $dataintegritycode = $cfg->get("mntdataintegritycode");
        $successurl=JURI::base(false)."index.php?option=com_caddy&action=paysuccess";
        $failurl=JURI::base(false)."index.php?option=com_caddy&action=payfail";
        $currency = $cfg->get("currency");
        $signature = md5("{$merchantid}{$orderid}{$amount}{$currency}{$testmode}{$dataintegritycode}");

		if (!$merchantid) {
			echo "Merchant ID is not entered, please add this to the configuration first. PayAnyWay cannot be used!";
			return;
		}

		// add the details to the order
//		if (!$cart) return; // if there is no cart then exit.

		$html = "<form action='https://{$paymentserver}/assistant.htm' method='post'>";
   		$html .="<input type=\"$this->debugshow\" name=\"MNT_ID\" value=\"{$merchantid}\">";
   		$html .="<input type=\"$this->debugshow\" name=\"MNT_TRANSACTION_ID\" value=\"{$orderid}\">";
   		$html .="<input type=\"$this->debugshow\" name=\"MNT_CURRENCY_CODE\" value=\"{$currency}\">";
		$html .="<input type=\"$this->debugshow\" name=\"MNT_AMOUNT\" value=\"{$amount}\">";
		$html .="<input type=\"$this->debugshow\" name=\"MNT_TEST_MODE\" value=\"{$testmode}\">";
		$html .="<input type=\"$this->debugshow\" name=\"MNT_SIGNATURE\" value=\"{$signature}\">";
		$html .="<input type=\"$this->debugshow\" name=\"MNT_SUCCESS_URL\" value=\"{$successurl}\">";
		$html .="<input type=\"$this->debugshow\" name=\"MNT_FAIL_URL\" value=\"{$failurl}\">";

		$html .= JText::_('SC_WE_USE_PAYANYWAY');

		$html .='<p><input type="submit" value="PayAnyWay" name="submit"></p>';
		$html .= "</form>";
        
		echo $html; // display the html.
	}
}
?>